<template>
   <div class="modal d-flex align-items-center row m-0">
        <div class="container col-6 bg-light rounded table-responsive p-3 shadow">
            <form @submit.prevent class="form">
                <h3 class="text-center mb-3">Добавление клиента</h3>
                <edit-table :items="inputItems"></edit-table>
                <div class="mt-3 cust-heihgt  m-auto">
                    <transition name="fade">
                        <p v-show="isShow" class="bg-success text-white p-2 text-center rounded shadow">Клиент успешно добавлен!</p>
                    </transition>
                </div>
                <div class="d-flex justify-content-end">
                    <button-send-form :disabled="isDisabled" @click="pushData" class="btn-primary mx-2"> Добавить</button-send-form> 
                    <router-link :to="{name: 'clients'}" class="btn btn-secondary">Закрыть</router-link>
                </div>                
            </form>
        </div>
    </div>
</template>

<script>
import moment from 'moment';
import {ref, onMounted, computed} from 'vue';
import { useStore } from 'vuex'
import {useRouter, useRoute } from 'vue-router';
import {mapActions, mapGetters, mapMutations} from 'vuex';
import axios from "axios";

export default {
    components: {
        moment,
    },
    setup(){
        const store = useStore();
        const router = useRouter();
        const route = useRoute();
        const isShow = ref(false);
        const isDisabled = ref(false);
        

        
        const listItems = computed(() => mapGetters(['LIST_ITEMS']));

        function addListItems(data){store.getters('ADD_LIST_ITEMS_FROM_API', data)};
        
        const inputItems = computed(() => store.getters.CLIENT_INPUT_ITEMS);
       
        function pushData(){
            
            const arr = [];

            if(inputItems.value[0].value){
               
                inputItems.value.forEach(el => {
                    arr[el.name] = el.value;
                    arr['id'] =  Date.now();
                    
                    if(el.name === 'date_create'){
                        arr['date_create'] = (!el.value) ?  moment().format("YYYY-MM-DD") : el.value;
                    }
                })
        
                // addListItems(data);
               
                
               console.log({...arr})

                axios({
                method: 'post',
                url: 'http://localhost/api/client-save',
                data: JSON.stringify({...arr}),
                headers: { 
                  
                    accept: 'application/json', 
                },
                // credentials: 'include'
            })
                .then(function (response) {
                  //handle success
                  console.log(response.data.data);
                })
                .catch(function (response) {
                  //handle error
                  console.log(response);
                }
            );
                

                isDisabled.value = true;
                showMessage(inputItems.value,'clients');
                
            }else{
                alert('Заполните обязательные поля!')
                isDisabled.value = false;
            }
           
        }
        
       
       
        function showMessage(arr,rout){
            isShow.value = !isShow.value;
            setTimeout(() => {
                isShow.value = !isShow.value;
                router.push({name: rout});
                arr.forEach(el => 
                   el.value = ''
                )
            }, 1000); 
        }
        
        return {
            inputItems,
            listItems,
            isShow,
            isDisabled,
            pushData
        }
    }
}
</script>

<style>

</style>
